> {-# LANGUAGE NoMonomorphismRestriction #-}
> {-# LANGUAGE TypeOperators #-}
> {-# LANGUAGE FlexibleContexts #-}

> module Setting where

> import Control.Monad.Trans
> import Control.Monad.State
> import Control.Monad.Reader
> import Control.Monad.Error
> import Control.Monad.Identity
> import Control.Monad.Zipper -- hiding (from, to, (:><:), hcomp) --, getv, putv, o, i, vcomp)

> import Control.Monad.Views
> --import Mask hiding (inc, ifpos1)

> data Counter1  = Counter1
> data Counter2  = Counter2

> inc :: MonadState Int m => m Int
> inc = do  x <- get 
>           put (x+1)
>           return (x+1)
>
> assert :: MonadError String m => Bool -> m ()
> assert test = if  test  
>                   then return () 
>                   else throwError "Assertion failed"

> comp :: (MonadState Int m, MonadError String m) => m ()
> comp = do  x <- inc 
>            assert (x > 0)

> type M1 = StateT Int (ErrorT String Identity)
> type M2 = ErrorT String (StateT Int Identity)

> runM1 :: Int -> M1 a -> Either String (a, Int)
> runM1 n = runIdentity . runErrorT . flip runStateT n
>
> runM2 :: Int -> M2 a -> (Either String a, Int)
> runM2 n = runIdentity . flip runStateT n . runErrorT

> doubleInc :: (MonadState Int (t m), MonadState Int m, MonadTrans t) => t m ()
> doubleInc = inc >> lift inc >> return ()

> run c = runIdentity $ runStateT (runStateT c 0) 5

> run2 c = runIdentity $ runStateT (runStateT (runStateT c 0) 5) 10

> type M3 = (StateT Int :> StateT Int) Identity

> ifpos1 :: MonadState Int m => m Int -> m Int
> ifpos1 c =  do  x <- get
>                 if  x > 0 
>                     then c 
>                     else return 0

> runM c = runIdentity (runErrorT (runErrorT ((runStateT (runStateT c 0) 5))))

> type M = StateT Int (StateT Int (ErrorT String (ErrorT String Identity)))

> client :: M Int
> client = bifrom m1 (ifpos1 (bito m1 (bifrom m2 (comp >> get))))
>   where  m1 = o
>          m2 = i `vcomp` o `vcomp` o `vcomp` i

> client' :: M Int
> client' = bifrom m1 (ifpos1 (bito m1 (bifrom m2 comp >> from m3 ask)))
>   where  m1  = o
>          m2  = i `vcomp` o `vcomp` o `vcomp` i
>          m3  = r1




-- Nominal Masks

-- > data Err2     = Err2

-- > client''  = ifpos1 ((comp >> get) `luse` (Counter1 :&: Err2))

-- > add  :: (Monad m, MonadState Int n1, MonadState Int n2) 
-- >      => (n1 :><: m) -> (n2 :><: m) -> m ()
-- > add xref yref  = do  x <- getv xref
-- >                      y <- getv yref
-- >                      putv xref (x + y)
